<?php
/**
 * Email
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  OpenAPI\Client
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * orchd
 *
 * orchd API docs
 *
 * The version of the OpenAPI document: 9.1.1
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace OpenAPI\Client\Model;

use \ArrayAccess;
use \OpenAPI\Client\ObjectSerializer;

/**
 * Email Class Doc Comment
 *
 * @category Class
 * @package  OpenAPI\Client
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class Email implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'Email';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'string',
        'website_id' => 'string',
        'mailbox_name' => 'string',
        'address' => 'string',
        'aliases' => 'string[]',
        'mailbox_id' => 'string',
        'status' => '\OpenAPI\Client\Model\EmailStatus',
        'quota' => '\OpenAPI\Client\Model\Quota',
        'autoresponders_count' => 'int',
        'forwarders_count' => 'int',
        'created_at' => 'string',
        'email_kind' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'id' => 'uuid',
        'website_id' => 'uuid',
        'mailbox_name' => null,
        'address' => null,
        'aliases' => null,
        'mailbox_id' => 'uuid',
        'status' => null,
        'quota' => null,
        'autoresponders_count' => null,
        'forwarders_count' => null,
        'created_at' => null,
        'email_kind' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'website_id' => 'websiteId',
        'mailbox_name' => 'mailboxName',
        'address' => 'address',
        'aliases' => 'aliases',
        'mailbox_id' => 'mailboxId',
        'status' => 'status',
        'quota' => 'quota',
        'autoresponders_count' => 'autorespondersCount',
        'forwarders_count' => 'forwardersCount',
        'created_at' => 'createdAt',
        'email_kind' => 'emailKind'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'website_id' => 'setWebsiteId',
        'mailbox_name' => 'setMailboxName',
        'address' => 'setAddress',
        'aliases' => 'setAliases',
        'mailbox_id' => 'setMailboxId',
        'status' => 'setStatus',
        'quota' => 'setQuota',
        'autoresponders_count' => 'setAutorespondersCount',
        'forwarders_count' => 'setForwardersCount',
        'created_at' => 'setCreatedAt',
        'email_kind' => 'setEmailKind'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'website_id' => 'getWebsiteId',
        'mailbox_name' => 'getMailboxName',
        'address' => 'getAddress',
        'aliases' => 'getAliases',
        'mailbox_id' => 'getMailboxId',
        'status' => 'getStatus',
        'quota' => 'getQuota',
        'autoresponders_count' => 'getAutorespondersCount',
        'forwarders_count' => 'getForwardersCount',
        'created_at' => 'getCreatedAt',
        'email_kind' => 'getEmailKind'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    const EMAIL_KIND_NORMAL = 'normal';
    const EMAIL_KIND_INTERNAL = 'internal';

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getEmailKindAllowableValues()
    {
        return [
            self::EMAIL_KIND_NORMAL,
            self::EMAIL_KIND_INTERNAL,
        ];
    }

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['id'] = $data['id'] ?? null;
        $this->container['website_id'] = $data['website_id'] ?? null;
        $this->container['mailbox_name'] = $data['mailbox_name'] ?? null;
        $this->container['address'] = $data['address'] ?? null;
        $this->container['aliases'] = $data['aliases'] ?? null;
        $this->container['mailbox_id'] = $data['mailbox_id'] ?? null;
        $this->container['status'] = $data['status'] ?? null;
        $this->container['quota'] = $data['quota'] ?? null;
        $this->container['autoresponders_count'] = $data['autoresponders_count'] ?? null;
        $this->container['forwarders_count'] = $data['forwarders_count'] ?? null;
        $this->container['created_at'] = $data['created_at'] ?? null;
        $this->container['email_kind'] = $data['email_kind'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if ($this->container['id'] === null) {
            $invalidProperties[] = "'id' can't be null";
        }
        if ($this->container['website_id'] === null) {
            $invalidProperties[] = "'website_id' can't be null";
        }
        if ($this->container['address'] === null) {
            $invalidProperties[] = "'address' can't be null";
        }
        if ($this->container['aliases'] === null) {
            $invalidProperties[] = "'aliases' can't be null";
        }
        if ($this->container['status'] === null) {
            $invalidProperties[] = "'status' can't be null";
        }
        if ($this->container['autoresponders_count'] === null) {
            $invalidProperties[] = "'autoresponders_count' can't be null";
        }
        if ($this->container['forwarders_count'] === null) {
            $invalidProperties[] = "'forwarders_count' can't be null";
        }
        if ($this->container['created_at'] === null) {
            $invalidProperties[] = "'created_at' can't be null";
        }
        if ($this->container['email_kind'] === null) {
            $invalidProperties[] = "'email_kind' can't be null";
        }
        $allowedValues = $this->getEmailKindAllowableValues();
        if (!is_null($this->container['email_kind']) && !in_array($this->container['email_kind'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'email_kind', must be one of '%s'",
                $this->container['email_kind'],
                implode("', '", $allowedValues)
            );
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return string
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param string $id id
     *
     * @return self
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets website_id
     *
     * @return string
     */
    public function getWebsiteId()
    {
        return $this->container['website_id'];
    }

    /**
     * Sets website_id
     *
     * @param string $website_id website_id
     *
     * @return self
     */
    public function setWebsiteId($website_id)
    {
        $this->container['website_id'] = $website_id;

        return $this;
    }

    /**
     * Gets mailbox_name
     *
     * @return string|null
     */
    public function getMailboxName()
    {
        return $this->container['mailbox_name'];
    }

    /**
     * Sets mailbox_name
     *
     * @param string|null $mailbox_name mailbox_name
     *
     * @return self
     */
    public function setMailboxName($mailbox_name)
    {
        $this->container['mailbox_name'] = $mailbox_name;

        return $this;
    }

    /**
     * Gets address
     *
     * @return string
     */
    public function getAddress()
    {
        return $this->container['address'];
    }

    /**
     * Sets address
     *
     * @param string $address address
     *
     * @return self
     */
    public function setAddress($address)
    {
        $this->container['address'] = $address;

        return $this;
    }

    /**
     * Gets aliases
     *
     * @return string[]
     */
    public function getAliases()
    {
        return $this->container['aliases'];
    }

    /**
     * Sets aliases
     *
     * @param string[] $aliases aliases
     *
     * @return self
     */
    public function setAliases($aliases)
    {
        $this->container['aliases'] = $aliases;

        return $this;
    }

    /**
     * Gets mailbox_id
     *
     * @return string|null
     */
    public function getMailboxId()
    {
        return $this->container['mailbox_id'];
    }

    /**
     * Sets mailbox_id
     *
     * @param string|null $mailbox_id mailbox_id
     *
     * @return self
     */
    public function setMailboxId($mailbox_id)
    {
        $this->container['mailbox_id'] = $mailbox_id;

        return $this;
    }

    /**
     * Gets status
     *
     * @return \OpenAPI\Client\Model\EmailStatus
     */
    public function getStatus()
    {
        return $this->container['status'];
    }

    /**
     * Sets status
     *
     * @param \OpenAPI\Client\Model\EmailStatus $status status
     *
     * @return self
     */
    public function setStatus($status)
    {
        $this->container['status'] = $status;

        return $this;
    }

    /**
     * Gets quota
     *
     * @return \OpenAPI\Client\Model\Quota|null
     */
    public function getQuota()
    {
        return $this->container['quota'];
    }

    /**
     * Sets quota
     *
     * @param \OpenAPI\Client\Model\Quota|null $quota quota
     *
     * @return self
     */
    public function setQuota($quota)
    {
        $this->container['quota'] = $quota;

        return $this;
    }

    /**
     * Gets autoresponders_count
     *
     * @return int
     */
    public function getAutorespondersCount()
    {
        return $this->container['autoresponders_count'];
    }

    /**
     * Sets autoresponders_count
     *
     * @param int $autoresponders_count autoresponders_count
     *
     * @return self
     */
    public function setAutorespondersCount($autoresponders_count)
    {
        $this->container['autoresponders_count'] = $autoresponders_count;

        return $this;
    }

    /**
     * Gets forwarders_count
     *
     * @return int
     */
    public function getForwardersCount()
    {
        return $this->container['forwarders_count'];
    }

    /**
     * Sets forwarders_count
     *
     * @param int $forwarders_count forwarders_count
     *
     * @return self
     */
    public function setForwardersCount($forwarders_count)
    {
        $this->container['forwarders_count'] = $forwarders_count;

        return $this;
    }

    /**
     * Gets created_at
     *
     * @return string
     */
    public function getCreatedAt()
    {
        return $this->container['created_at'];
    }

    /**
     * Sets created_at
     *
     * @param string $created_at created_at
     *
     * @return self
     */
    public function setCreatedAt($created_at)
    {
        $this->container['created_at'] = $created_at;

        return $this;
    }

    /**
     * Gets email_kind
     *
     * @return string
     */
    public function getEmailKind()
    {
        return $this->container['email_kind'];
    }

    /**
     * Sets email_kind
     *
     * @param string $email_kind email_kind
     *
     * @return self
     */
    public function setEmailKind($email_kind)
    {
        $allowedValues = $this->getEmailKindAllowableValues();
        if (!in_array($email_kind, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'email_kind', must be one of '%s'",
                    $email_kind,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['email_kind'] = $email_kind;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


