<?php
/**
 * UpdateEmail
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  OpenAPI\Client
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * orchd
 *
 * orchd API docs
 *
 * The version of the OpenAPI document: 9.1.1
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace OpenAPI\Client\Model;

use \ArrayAccess;
use \OpenAPI\Client\ObjectSerializer;

/**
 * UpdateEmail Class Doc Comment
 *
 * @category Class
 * @package  OpenAPI\Client
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class UpdateEmail implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'UpdateEmail';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'mailbox_name' => 'string',
        'mailbox_password' => 'string',
        'aliases' => 'string[]',
        'forwarders' => 'string[]',
        'has_mailbox' => 'bool',
        'status' => '\OpenAPI\Client\Model\EmailStatus',
        'quota' => 'int',
        'spam_threshold' => 'int',
        'spam_delivery' => 'string',
        'blacklist' => 'string[]',
        'whitelist' => 'string[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'mailbox_name' => null,
        'mailbox_password' => null,
        'aliases' => null,
        'forwarders' => null,
        'has_mailbox' => null,
        'status' => null,
        'quota' => null,
        'spam_threshold' => null,
        'spam_delivery' => null,
        'blacklist' => null,
        'whitelist' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'mailbox_name' => 'mailboxName',
        'mailbox_password' => 'mailboxPassword',
        'aliases' => 'aliases',
        'forwarders' => 'forwarders',
        'has_mailbox' => 'hasMailbox',
        'status' => 'status',
        'quota' => 'quota',
        'spam_threshold' => 'spamThreshold',
        'spam_delivery' => 'spamDelivery',
        'blacklist' => 'blacklist',
        'whitelist' => 'whitelist'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'mailbox_name' => 'setMailboxName',
        'mailbox_password' => 'setMailboxPassword',
        'aliases' => 'setAliases',
        'forwarders' => 'setForwarders',
        'has_mailbox' => 'setHasMailbox',
        'status' => 'setStatus',
        'quota' => 'setQuota',
        'spam_threshold' => 'setSpamThreshold',
        'spam_delivery' => 'setSpamDelivery',
        'blacklist' => 'setBlacklist',
        'whitelist' => 'setWhitelist'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'mailbox_name' => 'getMailboxName',
        'mailbox_password' => 'getMailboxPassword',
        'aliases' => 'getAliases',
        'forwarders' => 'getForwarders',
        'has_mailbox' => 'getHasMailbox',
        'status' => 'getStatus',
        'quota' => 'getQuota',
        'spam_threshold' => 'getSpamThreshold',
        'spam_delivery' => 'getSpamDelivery',
        'blacklist' => 'getBlacklist',
        'whitelist' => 'getWhitelist'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    const SPAM_DELIVERY_SPAM_FOLDER = 'spamFolder';
    const SPAM_DELIVERY_REJECT = 'reject';

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getSpamDeliveryAllowableValues()
    {
        return [
            self::SPAM_DELIVERY_SPAM_FOLDER,
            self::SPAM_DELIVERY_REJECT,
        ];
    }

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['mailbox_name'] = $data['mailbox_name'] ?? null;
        $this->container['mailbox_password'] = $data['mailbox_password'] ?? null;
        $this->container['aliases'] = $data['aliases'] ?? null;
        $this->container['forwarders'] = $data['forwarders'] ?? null;
        $this->container['has_mailbox'] = $data['has_mailbox'] ?? null;
        $this->container['status'] = $data['status'] ?? null;
        $this->container['quota'] = $data['quota'] ?? null;
        $this->container['spam_threshold'] = $data['spam_threshold'] ?? null;
        $this->container['spam_delivery'] = $data['spam_delivery'] ?? null;
        $this->container['blacklist'] = $data['blacklist'] ?? null;
        $this->container['whitelist'] = $data['whitelist'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        $allowedValues = $this->getSpamDeliveryAllowableValues();
        if (!is_null($this->container['spam_delivery']) && !in_array($this->container['spam_delivery'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'spam_delivery', must be one of '%s'",
                $this->container['spam_delivery'],
                implode("', '", $allowedValues)
            );
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets mailbox_name
     *
     * @return string|null
     */
    public function getMailboxName()
    {
        return $this->container['mailbox_name'];
    }

    /**
     * Sets mailbox_name
     *
     * @param string|null $mailbox_name mailbox_name
     *
     * @return self
     */
    public function setMailboxName($mailbox_name)
    {
        $this->container['mailbox_name'] = $mailbox_name;

        return $this;
    }

    /**
     * Gets mailbox_password
     *
     * @return string|null
     */
    public function getMailboxPassword()
    {
        return $this->container['mailbox_password'];
    }

    /**
     * Sets mailbox_password
     *
     * @param string|null $mailbox_password mailbox_password
     *
     * @return self
     */
    public function setMailboxPassword($mailbox_password)
    {
        $this->container['mailbox_password'] = $mailbox_password;

        return $this;
    }

    /**
     * Gets aliases
     *
     * @return string[]|null
     */
    public function getAliases()
    {
        return $this->container['aliases'];
    }

    /**
     * Sets aliases
     *
     * @param string[]|null $aliases aliases
     *
     * @return self
     */
    public function setAliases($aliases)
    {
        $this->container['aliases'] = $aliases;

        return $this;
    }

    /**
     * Gets forwarders
     *
     * @return string[]|null
     */
    public function getForwarders()
    {
        return $this->container['forwarders'];
    }

    /**
     * Sets forwarders
     *
     * @param string[]|null $forwarders forwarders
     *
     * @return self
     */
    public function setForwarders($forwarders)
    {
        $this->container['forwarders'] = $forwarders;

        return $this;
    }

    /**
     * Gets has_mailbox
     *
     * @return bool|null
     */
    public function getHasMailbox()
    {
        return $this->container['has_mailbox'];
    }

    /**
     * Sets has_mailbox
     *
     * @param bool|null $has_mailbox has_mailbox
     *
     * @return self
     */
    public function setHasMailbox($has_mailbox)
    {
        $this->container['has_mailbox'] = $has_mailbox;

        return $this;
    }

    /**
     * Gets status
     *
     * @return \OpenAPI\Client\Model\EmailStatus|null
     */
    public function getStatus()
    {
        return $this->container['status'];
    }

    /**
     * Sets status
     *
     * @param \OpenAPI\Client\Model\EmailStatus|null $status status
     *
     * @return self
     */
    public function setStatus($status)
    {
        $this->container['status'] = $status;

        return $this;
    }

    /**
     * Gets quota
     *
     * @return int|null
     */
    public function getQuota()
    {
        return $this->container['quota'];
    }

    /**
     * Sets quota
     *
     * @param int|null $quota quota
     *
     * @return self
     */
    public function setQuota($quota)
    {
        $this->container['quota'] = $quota;

        return $this;
    }

    /**
     * Gets spam_threshold
     *
     * @return int|null
     */
    public function getSpamThreshold()
    {
        return $this->container['spam_threshold'];
    }

    /**
     * Sets spam_threshold
     *
     * @param int|null $spam_threshold spam_threshold
     *
     * @return self
     */
    public function setSpamThreshold($spam_threshold)
    {
        $this->container['spam_threshold'] = $spam_threshold;

        return $this;
    }

    /**
     * Gets spam_delivery
     *
     * @return string|null
     */
    public function getSpamDelivery()
    {
        return $this->container['spam_delivery'];
    }

    /**
     * Sets spam_delivery
     *
     * @param string|null $spam_delivery spam_delivery
     *
     * @return self
     */
    public function setSpamDelivery($spam_delivery)
    {
        $allowedValues = $this->getSpamDeliveryAllowableValues();
        if (!is_null($spam_delivery) && !in_array($spam_delivery, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'spam_delivery', must be one of '%s'",
                    $spam_delivery,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['spam_delivery'] = $spam_delivery;

        return $this;
    }

    /**
     * Gets blacklist
     *
     * @return string[]|null
     */
    public function getBlacklist()
    {
        return $this->container['blacklist'];
    }

    /**
     * Sets blacklist
     *
     * @param string[]|null $blacklist blacklist
     *
     * @return self
     */
    public function setBlacklist($blacklist)
    {
        $this->container['blacklist'] = $blacklist;

        return $this;
    }

    /**
     * Gets whitelist
     *
     * @return string[]|null
     */
    public function getWhitelist()
    {
        return $this->container['whitelist'];
    }

    /**
     * Sets whitelist
     *
     * @param string[]|null $whitelist whitelist
     *
     * @return self
     */
    public function setWhitelist($whitelist)
    {
        $this->container['whitelist'] = $whitelist;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


